SystemOrganization addCategory: #Objetos3SelfModification!
SystemOrganization addCategory: #'Objetos3SelfModification-Tests'!

Object subclass: #ClassDiff
	instanceVariableNames: 'class1 class2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification'!

!ClassDiff class methodsFor: 'as yet unclassified' stamp: 'Sawady 11/6/2012 19:33'!
new

^ self shouldNotImplement! !

!ClassDiff class methodsFor: 'as yet unclassified' stamp: 'Sawady 11/6/2012 19:32'!
newWith: class1 and: class2

^ super new initializeWith: class1 and: class2.! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class1
	^ class1! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class1: anObject
	class1 := anObject! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class2
	^ class2! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class2: anObject
	class2 := anObject! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 20:10'!
createCommonSuperClass: newClassName

RBAddClassRefactoring 
       addClass: newClassName 
       superclass: Object
       subclasses: (OrderedCollection new add: class1; add: class2; yourself) 
       category: class1 superclass category! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 17:42'!
getMethodDiffBetweenClasses
| methodDictDiff methodDictClass1 methodDictClass2 |

methodDictDiff := Dictionary new.

methodDictClass1 := class1 methodDictionary collect: [:i | i getSource ].
methodDictClass2 := class2  methodDictionary collect: [:i | i getSource ].

(methodDictClass1 associations intersection: methodDictClass2 associations) do: [:x | methodDictDiff add: x ].

^ methodDictDiff.
! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 17:43'!
getVarDiffBetweenClasses

^ class1 instVarNames intersection: class2 instVarNames.! !

!ClassDiff methodsFor: 'initialize-release' stamp: 'Sawady 11/6/2012 19:36'!
initializeWith: aClass and: anotherClass

class1 := aClass.
class2 := anotherClass.! !

!ClassDiff methodsFor: 'public interface' stamp: 'Sawady 11/6/2012 20:10'!
makeDiff: newClassName

| commonSuperClass |

self validateSameParentClass.

self createCommonSuperClass: newClassName.

commonSuperClass := RBClass named: newClassName asSymbol.
	
self pullUpMethods: commonSuperClass.

self pullUpVars: commonSuperClass.! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 20:08'!
pullUpMethods: newRBClass
| selectorsToRemove |

selectorsToRemove := self getMethodDiffBetweenClasses keys.

(RBPullUpMethodRefactoring pullUp: selectorsToRemove from: class1) execute.

(RBRemoveMethodRefactoring removeMethods: selectorsToRemove from: class2) execute.! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 20:12'!
pullUpVars: newRBClass

self getVarDiffBetweenClasses do: [ :v | 
      (RBPullUpInstanceVariableRefactoring variable: v class: class1) execute.
	(RBRemoveInstanceVariableRefactoring variable: v class: class2) execute.
]! !

!ClassDiff methodsFor: 'validation' stamp: 'Sawady 11/6/2012 18:02'!
validateSameParentClass

(class1 superclass = class2 superclass) ifFalse: [ 
	Exception new signal: 'The two classes must have the same parent class' 
].! !

Object subclass: #Example1
	instanceVariableNames: 'v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!Example1 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:14'!
m1
^'m1'! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m2
^'m2'! !

Object subclass: #Example2
	instanceVariableNames: 'v1 v3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!Example2 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m1
^'m1'! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m3
^'m3'! !

TestCase subclass: #ClassDiffTest
	instanceVariableNames: 'classDiff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!ClassDiffTest methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:08'!
classDiff
	^ classDiff! !

!ClassDiffTest methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:08'!
classDiff: anObject
	classDiff := anObject! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 10/27/2012 08:06'!
setUp

classDiff := ClassDiff new.
classDiff class1: Example1.
classDiff class2: Example2.! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 11/1/2012 23:32'!
testGetMethodDiffBetweenClasses
	"Tests ClassDiff>>#getMethodDiffBetweenClasses"
	| methodDict |
	methodDict := self classDiff getMethodDiffBetweenClasses.

	self assert: ( methodDict size = 1).
	self assert: ( methodDict keys includesAllOf: (Set with: #m1)).! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 11/1/2012 23:35'!
testGetVarDiffBetweenClasses
	"Tests ClassDiffs>>#getVarDiffBetweenClasses"
	| varDiff |
	varDiff := self classDiff getVarDiffBetweenClasses.
	self assert: varDiff size = 1.
	self assert: (varDiff includesAllOf: (Set with: 'v1'))! !
